import processing.sound.*;
SoundFile file;

int xspacing = 10;   
int w;              

float theta = 0.0;     
float amplitude = 30.0;     
float period = 500.0;      
float dx;                  
float[] yvalues;  

void setup() {
  size(640, 360);
  w = width+16;
  dx = (TWO_PI / period) * xspacing;
  yvalues = new float[w/xspacing];
  
  file = new SoundFile(this, "shPiano.mp3");
  file.play();  
}

void draw() {
  background(0);
  calcWave();
  renderWave();
}

void calcWave() {
  theta += 0.02;

  float x = theta;
  for (int i = 0; i < yvalues.length; i++) {
    yvalues[i] = sin(x)*amplitude;
    x+=dx;
  }
}

void renderWave() {
  float r, g, b;
  r = random(255);
  g = random(255);
  b = random(255);

  noStroke();
  fill(r, g, b);
  float val = randomGaussian();
  for (int x = 0; x < yvalues.length; x++) {
    ellipse(x*xspacing, height/4+yvalues[x], 2, 2);
    ellipse(x*xspacing*val, (height/4)*3+yvalues[x], 2, 2);
  }
}
